#Include Once "wx-c/wx.bi"
#Include Once "mdLanguage.bi"

Declare Function App_OnInit WXCALL ( ) As wxBool
Declare Function App_OnExit WXCALL ( ) As wxInt

Declare Sub textctrl0_event WXCALL ( ByVal event As wxEvent Ptr, ByVal iListener As wxInt )
Declare Sub button0_event WXCALL (event As wxEvent Ptr,iListener As wxInt )
''
'' Translate FBString to wxString
''
Function fbstring_to_wxString( ByVal fbstr As String ) As wxString Ptr
	Dim As wxString Ptr ret
	ret = wxString_ctorUTF8( fbstr )
	Return ret
End Function

''
'' Translate wxString to FBString
''
Function wxString_to_fbstring( ByVal wxstr As wxString Ptr ) As String
	Dim As String ret
	Dim As Integer i
	For i = 0 To wxString_GetLength( wxstr )
		If wxString_CharAtUTF16( wxstr, i ) <> 0 Then
			ret += Chr( wxString_CharAtUTF16( wxstr, i ) )
		EndIf
	Next
	Return ret
End Function


Dim Shared As wxApp Ptr wx_app
Dim Shared As wxFrame Ptr wx_frame
Dim Shared As wxPanel Ptr wx_panel
Dim Shared As wxStaticText Ptr stattext0

Dim Shared As String defaultLang
defaultLang = "de"
loadCustomLanguage(default, defaultLang, "")

Function App_OnInit WXCALL ( ) As wxBool
	
	wx_frame = wxFrame_ctor( )
	wxFrame_Create( wx_frame, WX_NULL, -1, fbstring_to_wxString(( getTranslation(default, "label") )), 483, 164, 263, 154, wxFRAME_DEFAULT_STYLE Or wxCLOSE_BOX Xor wxMAXIMIZE_BOX Xor wxRESIZE_BORDER, WX_NULL )
	wx_panel = wxPanel_ctor2( wx_frame, -1, -1, -1, -1, -1, 0, WX_NULL )
	
	''
	'' create widget stattext0
	''
	stattext0 = wxStaticText_ctor( )
	wxStaticText_Create( stattext0, wx_panel, -1, fbstring_to_wxString(( getTranslation(default, "your-name") )), 10, 20, -1, -1, 0, 0 )
	
	
	''
	'' create widget textctrl0
	''
	Dim As wxTextCtrl Ptr textctrl0
	textctrl0 = wxTextCtrl_ctor( )
	wxTextCtrl_Create( textctrl0, wx_panel, -1, fbstring_to_wxString(( "" )), 10, 50, -1, -1, 0, 0, 0 )
	
	wxEvtHandler_Proxy( textctrl0, Cast(EventListener, @textctrl0_event) )
	wxEvtHandler_Connect( textctrl0, wxEvent_EVT_COMMAND_TEXT_UPDATED( ), -1, -1, 0 )
	wxEvtHandler_Connect( textctrl0, wxEvent_EVT_LEAVE_WINDOW( ), -1, -1, 0 )
	
	''
	'' create widget button0
	''
	Dim As wxButton Ptr button0
	button0 = wxButton_ctor( )
	wxButton_Create( button0, wx_panel, -1, fbstring_to_wxString(( getTranslation(default, "change-language") )), 10, 80, -1, -1, 0, 0, 0 )
	
	wxEvtHandler_Proxy( button0, Cast(EventListener, @button0_event) )
	wxEvtHandler_Connect( button0, wxEvent_EVT_COMMAND_BUTTON_CLICKED( ), -1, -1, 0 )
	
	wxWindow_Show( wx_frame, 1 )
	wxApp_OnInit( wx_app )
	Return 1
	
End Function

Function App_OnExit WXCALL ( ) As wxInt
	
	Return wxApp_OnExit( wx_app )
	
End Function

Sub textctrl0_event WXCALL ( ByVal event As wxEvent Ptr, ByVal iListener As wxInt )
	
	Select Case wxEvent_GetEventType( event )
		Case wxEvent_EVT_COMMAND_TEXT_UPDATED
			''add event handler code here
			Dim As wxTextCtrl Ptr temp = wxEvent_GetEventObject(event)
			'Dim As wxString Ptr hallo = wxString_ctorUTF8(getTranslation(default, "hello") & wxString_to_fbstring(wxTextCtrl_GetValue(temp)))
			Dim As wxString Ptr hallo = wxString_ctorUTF8(getTranslation(default, "test-two", wxString_to_fbstring(wxTextCtrl_GetValue(temp))))
			
			wxWindow_SetLabel(stattext0, hallo)
		Case wxEvent_EVT_LEAVE_WINDOW
			''add event handler code here
			
	End Select
	
End Sub

Sub button0_event WXCALL ( ByVal event As wxEvent Ptr, ByVal iListener As wxInt )
	
	Select Case wxEvent_GetEventType( event )
		Case wxEvent_EVT_COMMAND_BUTTON_CLICKED
			''add event handler code here
			If defaultLang = "de" Then
				defaultLang = "en"
			Else
				defaultLang = "de"
			EndIf
			loadCustomLanguage(default, defaultLang, "")
			
	End Select
	
End Sub


''main
wx_app = wxApp_ctor( )
wxApp_RegisterVirtual ( wx_app, @App_OnInit, @App_OnExit )
wxApp_Run( 0, 0 )
